/* draw_vports.c */

#include "head_usycams.h"
/*#include "attrib_usycams.h"*/
#include "def_usycams.h"
#include "objects.h"


draw_vp3()
{
 double vert1[2], vert2[2];
 int end[2],rot;
 char cc[5],cw[5],d1[5],an1[5],d4[5],an4[5],d3[5],an3[5],
      lr[5],ll[5];
 fmfonthandle f1,f2,f3,f4,f5,f6,f7;

 vert1[0]=0; vert1[1]=0;
 vert2[0]=0; vert2[1]=(YMAX2-YMAX1-1)*scala;

 rot=psii[counter];

 if(rot==0) rot=3600;
 sprintf(cc,"%4.2d", 360-rot/10);
 sprintf(cw,"%4.2d", 360-rot/10);
 sprintf(d1,"%4.3f", vp3_var[0]);
 sprintf(an1,"%5.2f", (vp3_var[1]*180/PI));
 sprintf(d3,"%4.3f", vp3_var[2]);
 sprintf(an3,"%5.2f", (vp3_var[3]*180/PI));
 sprintf(d4,"%4.3f", vp3_var[4]);
 sprintf(an4,"%5.2f", (vp3_var[5]*180/PI));
 sprintf(ll,"%5.3f", vp3_var[6]);
 sprintf(lr,"%5.3f", vp3_var[7]);

 screen_vp3();
 fminit();
 c3f(lblack);
 clear();

 f1 = fmfindfont("Times-Roman");
 f2 = fmscalefont(f1,13.0*scala); 
 f3 = fmfindfont("Symbol");
 f4 = fmscalefont(f3,14.0*scala);
 f5 = fmscalefont(f1,9.0*scala);
 f6 = fmfindfont("Times-Italic");
 f7 = fmscalefont(f6,14.0*scala);
 fmsetfont(f2);

 if(POS6) c3f(green); else c3f(red);
 bgnline();
  v2d(vert1);
  v2d(vert2);
 endline();

  pushmatrix();
     scale(scala,scala,1.);
     translate(95.,676.,0.);
     if(!NOR)  c3f(red); 
     else c3f(green);
     callobj(NORO);
     if(!NOR && CWR || CCW) c3f(green); else c3f(red);
     cmov2i((int)(-18), (int)(-32)); fmprstr(cw);
  popmatrix();
  pushmatrix();
     scale(scala,scala,1.);
     translate(44,676.,0.);
     c3f(yellow);
     rect(-34.,-34.,34.,34.);
     if(!CWR)  c3f(red); 
     else c3f(green);
     callobj(CWRO);
  popmatrix();
  pushmatrix();
     scale(scala,scala,1.);
     translate(146,676,0.);
     c3f(yellow);
     rect(-34.,-34.,34.,34.);
     if(!CCW)  c3f(red); 
     else c3f(green); 
     callobj(CCWR);
  popmatrix();

 if(DI_3_OSC)
  {
   pushmatrix();
     scale(scala,scala,1.);
     translate(95,597,0.);
     c3f(yellow);
     rect(-85,-34,85,34);
     fmsetfont(f7);
     cmov2(-80, -26); fmprstr("a");
     fmsetfont(f5);
     cmov2(-66, -29); fmprstr("1");
    fmsetfont(f2);
     if(!D1D)  c3f(red); else c3f(green);
     cmov2(37, -28); fmprstr(d1);
     callobj(D1DI);
   popmatrix();
   pushmatrix();
     scale(scala,scala,1.);
     translate(95,518,0.);
     c3f(yellow);
     rect(-85,-34,85,34);
     fmsetfont(f4);
     cmov2(-80, -26); fmprstr("a");
     fmsetfont(f5);
     cmov2(-66, -29); fmprstr("1");
     fmsetfont(f2);
     if(!A1D)  c3f(red); else c3f(green);
     cmov2(37,-28); fmprstr(an1);
     callobj(A1DI);
   popmatrix();
   pushmatrix();
     scale(scala,scala,1.);
     translate(95,439,0.);
     c3f(yellow);
     rect(-85,-34,85,34);
     fmsetfont(f7);
     cmov2(-80, -26); fmprstr("a");
     fmsetfont(f5);
     cmov2(-66, -29); fmprstr("4");
     fmsetfont(f2);
     if(!D4D)  c3f(red); else c3f(green);
     cmov2(37, -28); fmprstr(d4);
     callobj(D4DI);
   popmatrix();
   pushmatrix();
     scale(scala,scala,1.);
     translate(95,360,0.);
     c3f(yellow);
     rect(-85,-34,85,34);
     fmsetfont(f4);
     cmov2(-80, -26); fmprstr("a");
     fmsetfont(f5);
     cmov2(-66, -29); fmprstr("4");
     fmsetfont(f2);
     if(!A4D)  c3f(red); else c3f(green);
     cmov2(37, -28); fmprstr(an4);
     callobj(A4DI);
   popmatrix();
   pushmatrix();
     scale(scala,scala,1.);
     translate(95,281,0.);
     c3f(yellow);
     rect(-85,-34,85,34);
     fmsetfont(f4);
     cmov2(-80, -26); fmprstr("l");
     fmsetfont(f5);
     cmov2(-66, -29); fmprstr("1");
     fmsetfont(f2);
     if(!LLE)  c3f(red); else c3f(green);
     cmov2(37, -28); fmprstr(ll);
     callobj(LLEF);
   popmatrix();
   pushmatrix();
     scale(scala,scala,1.);
     translate(95,202,0.);
     c3f(yellow);
     rect(-85,-34,85,34);
     fmsetfont(f4);
     cmov2(-80, -26); fmprstr("l");
     fmsetfont(f5);
     cmov2(-66, -29); fmprstr("2");
     fmsetfont(f2);
     if(!LRI)  c3f(red); else c3f(green);
     cmov2(37,-28); fmprstr(lr);
     callobj(LRIG);
   popmatrix();
  }
 else if(DI_3_IND)
  {
   pushmatrix();
     scale(scala,scala,1.);
     translate(95,597,0.);
     c3f(yellow);
     rect(-85,-34,85,34);
     fmsetfont(f7);
     cmov2(-80, -26); fmprstr("a");
     fmsetfont(f5);
     cmov2(-66, -29); fmprstr("1");
     fmsetfont(f2);
     if(!D1D)  c3f(red); else c3f(green);
     cmov2(37, -28); fmprstr(d1);
     callobj(D1DI);
   popmatrix();
   pushmatrix();
     scale(scala,scala,1.);
     translate(95,518,0.);
     c3f(yellow);
     rect(-85,-34,85,34);
     fmsetfont(f4);
     cmov2(-80, -26); fmprstr("a");
     fmsetfont(f5);
     cmov2(-66, -29); fmprstr("1");
     fmsetfont(f2);
     if(!A1D)  c3f(red); else c3f(green);
     cmov2(37, -28); fmprstr(an1);
     callobj(A1DI);
   popmatrix();
   pushmatrix();
     scale(scala,scala,1.);
     translate(95,439,0.);
     c3f(yellow);
     rect(-85,-34,85,34);
     fmsetfont(f4);
     cmov2(-80, -26); fmprstr("l");
     fmsetfont(f5);
     cmov2(-66, -29); fmprstr("1");
     fmsetfont(f2);
     if(!LLE)  c3f(red); else c3f(green);
     cmov2(37, -28); fmprstr(ll);
     callobj(LLEF);
   popmatrix();
   pushmatrix();
     scale(scala,scala,1.);
     translate(95,360,0.);
     c3f(yellow);
     rect(-85,-34,85,34);
     fmsetfont(f4);
     cmov2(-80, -26); fmprstr("l");
     fmsetfont(f5);
     cmov2(-66, -29); fmprstr("2");
     fmsetfont(f2);
     if(!LRI)  c3f(red); else c3f(green);
     cmov2(37, -28); fmprstr(lr);
     callobj(LRIG);
   popmatrix();
  }
 else if(DI_4)
  {
   pushmatrix();
     scale(scala,scala,1.);
     translate(95,597,0.);
     c3f(yellow);
     rect(-85,-34,85,34);
     fmsetfont(f7);
     cmov2(-80, -26); fmprstr("a");
     fmsetfont(f5);
     cmov2(-66, -29); fmprstr("1");
     fmsetfont(f2);
     if(!D1D)  c3f(red); else c3f(green);
     cmov2(37, -28); fmprstr(d1);
     callobj(D1DI);
   popmatrix();
   pushmatrix();
     scale(scala,scala,1.);
     translate(95,518,0.);
     c3f(yellow);
     rect(-85,-34,85,34);
     fmsetfont(f4);
     cmov2(-80, -26); fmprstr("a");
     fmsetfont(f5);
     cmov2(-66, -29); fmprstr("1");
     fmsetfont(f2);
     if(!A1D)  c3f(red); else c3f(green);
     cmov2(37, -28); fmprstr(an1);
     callobj(A1DI);
   popmatrix();
   pushmatrix();
     scale(scala,scala,1.);
     translate(95,439,0.);
     c3f(yellow);
     rect(-85,-34,85,34);
     fmsetfont(f7);
     cmov2(-80, -26); fmprstr("a");
     fmsetfont(f5);
     cmov2(-66, -29); fmprstr("3");
     fmsetfont(f2);
     if(!D3D)  c3f(red); else c3f(green);
     cmov2(37, -28); fmprstr(d3);
     callobj(D3DI);
   popmatrix();
   pushmatrix();
     scale(scala,scala,1.);
     translate(95,360,0.);
     c3f(yellow);
     rect(-85,-34,85,34);
     fmsetfont(f4);
     cmov2(-80, -26); fmprstr("a");
     fmsetfont(f5);
     cmov2(-66, -29); fmprstr("3");
     fmsetfont(f2);
     if(!A3D)  c3f(red); else c3f(green);
     cmov2(37, -28); fmprstr(an3);
     callobj(A3DI);
   popmatrix();
   pushmatrix();
     scale(scala,scala,1.);
     translate(95,281,0.);
     c3f(yellow);
     rect(-85,-34,85,34);
     fmsetfont(f7);
     cmov2(-80, -26); fmprstr("a");
     fmsetfont(f5);
     cmov2(-66, -29); fmprstr("4");
     fmsetfont(f2);
     if(!D4D)  c3f(red); else c3f(green);
     cmov2(37, -28); fmprstr(d4);
     callobj(D4DI);
   popmatrix();
   pushmatrix();
     scale(scala,scala,1.);
     translate(95,202,0.);
     c3f(yellow);
     rect(-85,-34,85,34);
     fmsetfont(f4);
     cmov2(-80, -26); fmprstr("a");
     fmsetfont(f5);
     cmov2(-66, -29); fmprstr("4");
     fmsetfont(f2);
     if(!A4D)  c3f(red); else c3f(green);
     cmov2(37, -28); fmprstr(an4);
     callobj(A4DI);
   popmatrix();
   pushmatrix();
     scale(scala,scala,1.);
     translate(95,123,0.);
     c3f(yellow);
     rect(-85,-34,85,34);
     fmsetfont(f4);
     cmov2(-80, -26); fmprstr("l");
     fmsetfont(f5);
     cmov2(-66, -29); fmprstr("1");
     fmsetfont(f2);
     if(!LLE)  c3f(red); else c3f(green);
     cmov2(37, -28); fmprstr(ll);
     callobj(LLEF);
   popmatrix();
   pushmatrix();
     scale(scala,scala,1.);
     translate(95,44,0.);
     c3f(yellow);
     rect(-85,-34,85,34);
     fmsetfont(f4);
     cmov2(-80, -26); fmprstr("l");
     fmsetfont(f5);
     cmov2(-66, -29); fmprstr("2");
     fmsetfont(f2);
     if(!LRI)  c3f(red); else c3f(green);
     cmov2(37, -28); fmprstr(lr);
     callobj(LRIG);
   popmatrix();
  }

/*  rect(10.*scala,11.*scala,180.*scala,711.*scala);*/
 exitscreenmode();
}






