/* draw_vp4.c */

#include "head_usycams.h"
/*#include "attrib_usycams.h"*/
#include "def_usycams.h"
#include "objects.h"

draw_vp4(rise,retu)
int rise[1],retu[1];
{
 int i;
 float vert1[2], vert2[2];
 char dh[5],pm[5],p1[5],p2[5],p3[5],st[5];
 fmfonthandle f1,f2,f3,f4;

 vert1[0]=0; vert1[1]=YMAX0*scala;
 vert2[0]=0; vert2[1]=YMAX1*scala;

 sprintf(dh,"%5.2f", vp4_var[0]*180/PI);
 sprintf(pm,"%5.2f", vp4_var[1]*180/PI);
 sprintf(p1,"%5.3f", vp4_var[2]);
 sprintf(p2,"%5.3f", vp4_var[3]);
 sprintf(p3,"%5.3f", vp4_var[4]);
 sprintf(st,"%5.0d", (int)vp4_var[5]);

 screen_vp4();
 fminit();
 c3f(lblack);
 clear();

 f1 = fmfindfont("Times-Roman");
 f2 = fmscalefont(f1,13.0*scala);
 f3 = fmscalefont(f1,24.0*scala);
 f4 = fmscalefont(f1,10.0*scala);

 fmsetfont(f2);

 if(POS6) c3f(green); else c3f(red);
 bgnline();
  v2f(vert1);
  v2f(vert2);
 endline();

pushmatrix();
scale(scala,scala,1.);
 if(INDM || OSCM)
   {
     if(INDM)
       {
	 c3f(yellow);
	 rect(10.,10.,180.,100.);
	 rect(10.,110.,180.,200.);
	 rect(10.,210.,180.,293.);
	 pushmatrix();
	 translate(95.,155.,0.);
  	 c3f(green);
	 scale(140.,64.,1.);
         callobj(SPLI);
	 popmatrix();	 
	 fmsetfont(f3);
	 c3f(yellow);
	 cmov2(95-27, 241); fmprstr("IND");
	 cmov2(95-22, 43); fmprstr("OK");
       }
     else
       {
	 c3f(yellow);
	 rect(10.,10.,180.,60.);
	 rect(10.,70.,180.,120.);
	 rect(10.,130.,180.,180.);
	 rect(10.,190.,180.,240.);
	 rect(10.,250.,180.,293.);
	 pushmatrix();
	 translate(95.,155.,0.);
	 c3f(green);
	 scale(140.,30.,1.);
         callobj(SPLI);
	 popmatrix();
	 pushmatrix();
	 translate(95.,95.,0.);
	 rotate(1800,'x');
	 scale(140.,30.,1.);
         callobj(SPLI);	 
	 popmatrix();
	 c3f(yellow);
	 fmsetfont(f3);
	 cmov2(95-31, 261); fmprstr("OSC");
	 cmov2(95-40, 203); fmprstr("PROG.");
	 cmov2(95-22, 24); fmprstr("OK");  
       }
   }
 else
   {
     if(IND)
       {
	 pushmatrix();
	 c3f(yellow);
	 translate(95,280,0.);
	 rect(-85, -14, 85, 14);
         fmsetfont(f2);
	 sel_title_ind(rise);
	 popmatrix();
	 pushmatrix();
	 translate(25,200,0.); 
	 c3f(yellow);
	 rect(-15.,-55.,15.,55.);
	 if(!PHM) c3f(red); else c3f(green);
	 callobj(PHIM);
	 cmov2(46, (int)(-22)); fmprstr(pm);
	 popmatrix();
	 pushmatrix();
	 translate(115,200,0.);
	 callobj(FIND);
	 popmatrix();
	 pushmatrix();
	 translate(95,107,0.);
	 c3f(yellow);
	 rect(-85,-28,85,28);
	 if(!PS2) c3f(red); else c3f(green);
	 callobj(PSI2);
	 cmov2(-75, (int)(-22)); fmprstr(p2);
	 popmatrix();
	 pushmatrix();
	 translate(95,44,0.);
	 c3f(yellow);
	 rect(-85,-29,85,29);
	 if(!STP) c3f(red); else c3f(green);
	 pushmatrix();
	 scale(1.,.75,1.);
	 for(i=0;i<(int)vp4_var[5];i++)
	   {
	     pushmatrix();
	     rotate(900+3600/(int)vp4_var[5]*i,'z');
	     move2(0,0); draw2(30.,0.); 
	     popmatrix();
	   }       
	 popmatrix();
	 cmov2(-75, (int)(-23)); fmprstr(st);
	 popmatrix();
       }
     else
       {
	 pushmatrix();
	 c3f(yellow);
	 translate(95,279,0.);
	 rect(-85,-24,85,24);
         fmsetfont(f4);
	 sel_title_osc_rise(rise);
	 sel_title_osc_retu(retu);
         fmsetfont(f2);
	 popmatrix();
	 pushmatrix();
	 translate(95,201,0.);
	 callobj(FOSC);
	 popmatrix();
	 pushmatrix();
	 translate(95,127,0.);
	 c3f(yellow);     
	 rect(-85,-19,85,19);     
	 if(!PS1) c3f(red); else c3f(green);
	 callobj(PSI1);
	 cmov2(-75, (int)(-13)); fmprstr(p1);
	 popmatrix();
	 pushmatrix();
	 translate(95,78,0.);
	 c3f(yellow);
	 rect(-85,-19,85,19);     
	 if(!PS2) c3f(red); else c3f(green);
	 callobj(PSI2);
	 cmov2(-75, (int)(-13)); fmprstr(p2);
	 popmatrix();
	 pushmatrix();
	 translate(95,29,0);
	 c3f(yellow);
	 rect(-85,-19,85,19);     
	 if(!PS3) c3f(red); else c3f(green);
	 callobj(PSI3);
	 cmov2(-75, (int)(-13)); fmprstr(p3);
	 popmatrix();
	 pushmatrix();
	 translate(38, 232,0.);
	 if(!DPH) c3f(red); else c3f(green);
	 rect(-28,-13,28,13);
	 cmov2(-25, (int)(-6)); fmprstr(dh);
	 popmatrix();
	 pushmatrix();
	 translate(38, 170,0.);
	 if(!PHM) c3f(red); else c3f(green);
	 rect(-28,-13,28,13);
	 cmov2(-25, (int)(-6)); fmprstr(pm);
	 popmatrix();
       }
   }
popmatrix();
 exitscreenmode(); 
}

sel_title_ind(type)
int type[1];
{
  switch(type[0])
    {
    case 1:
      cmov2(-50, -7.5);
      fmprstr("HARMONIC");
      break;
    case 2:
      cmov2(-52, -7.5);
      fmprstr("CYCLOIDAL");
      break;
    case 3:
      cmov2(-54, -7.5);
      fmprstr("345 POLYN.");
      break;
    case 4:
      cmov2(-56, -7.5);
      fmprstr("4567 POLYN.");
      break;
    case 5:
      cmov2(-59, -7.5);
      fmprstr("MOD. TRAPEZ.");
      break;
    case 6:
      cmov2(-32, -7.5);
      fmprstr("GIVEN");
      break;
    }
}

sel_title_osc_rise(type)
int type[1];
{
  switch(type[0])
    {
    case 1:
      cmov2(-75, 8);
      fmprstr("RISE:        HARMONIC");
      break;
    case 2:
      cmov2(-75, 8);
      fmprstr("RISE:        CYCLOIDAL");
      break;
    case 3:
      cmov2(-75, 8);
      fmprstr("RISE:        345 POLYN.");
      break;
    case 4:
      cmov2(-75, 8);
      fmprstr("RISE:        4567 POLYN.");
      break;
    case 5:
      cmov2(-75, 8);
      fmprstr("RISE:        MOD. TRAPEZ.");
      break;
    case 6:
      cmov2(-75, 8);
      fmprstr("RISE:        GIVEN");
      break;
    }
}

sel_title_osc_retu(type)
int type[1];
{
  switch(type[0])
    {
    case 1:
      cmov2i((int)(-75), (int)(-14));
      fmprstr("RETURN: HARMONIC");
      break;
     case 2:
      cmov2i((int)(-75), (int)(-14));
      fmprstr("RETURN: CYCLOIDAL");
      break;
    case 3:
      cmov2i((int)(-75), (int)(-14));
      fmprstr("RETURN: 345 POLYN.");
      break;
    case 4:
      cmov2i((int)(-75), (int)(-14));
      fmprstr("RETURN: 4567 POLYN.");
      break;
    case 5:
      cmov2i((int)(-75), (int)(-14));
      fmprstr("RETURN: MOD. TRAPEZ.");
      break;
    case 6:
      cmov2i((int)(-75), (int)(-14));
      fmprstr("RETURN: GIVEN");
      break;
    }
}

