/* cs_3_osc_pr.c */

#include "head_usycams.h"
#include "def_usycams.h"
#include "objects.h"
#include "def_surfaces.h"

/*
double sc[6*POINTS+M][2][3],sf[6*POINTS+M][2][3]; 
double uc[6*POINTS+M][CPOINTS+1][3],uf[6*POINTS+M][CPOINTS+1][3]; 
double v_cam[6*POINTS+M][CPOINTS+1][3];
double v_fol[6*POINTS+M][CPOINTS+1][3];
float  nsc[6*POINTS+M][2][3],nsf[POINTS+M][2][3];
float  nuc[6*POINTS+M][CPOINTS+1][3],nuf[6*POINTS+M][CPOINTS+1][3];
float  nvc[6*POINTS+M][CPOINTS+1][3],nvf[6*POINTS+M][CPOINTS+1][3];
*/
cs_3_osc_pr(a1,alp1, a4,l)
double a1,alp1,a4,l[2];
{
 double phi,dphi,ddphi, z2,a3,da3;
 double p42[3], e42[3],de42[3];
 double p[3]={0,0,0};
 double num,den;
 double vph; 
 double psph;
 double m[3],mag, dummy;
 float n[3];
 double u[M][3],v[M][3];
 float  nu[M][3],nv[M][3];
 int i,j,k;

 for(i=0;i<=POINTS;i++){
     z2 = io[i][0];
     phi = io[i][1];
     dphi= io[i][2];
     ddphi=io[i][3];
     a3 = sin(alp1)*cos(phi)/dphi;
     da3= -sin(alp1)*(SQR(dphi)*sin(phi)+ddphi*cos(phi))/SQR(dphi);
     e42[0]=0;
     e42[1]=-sin(alp1);
     e42[2]= cos(alp1);
     p42[0]= a1+ a3*cos(phi)-a4*sin(phi);
     p42[1]= a3*cos(alp1)*sin(phi)+a4*cos(alp1)*cos(phi);
     p42[2]= a3*sin(alp1)*sin(phi)+a4*cos(phi)*sin(alp1)-z2;
     m[0] = dphi*(a3*cos(phi)-a4*sin(phi))-sin(alp1)+da3*sin(phi);
     dummy= a3*sin(phi)+a4*cos(phi);
     m[1] = dphi*cos(alp1)*dummy+da3*cos(phi)*cos(alp1);
     m[2] = dphi*sin(alp1)*dummy-da3*cos(phi)*sin(alp1);
     mag=sqrt(SQR(m[0])+SQR(m[1])+SQR(m[2]));
     for(j=0;j<3;j++){
	 nsc[i][0][j]=(float)m[i]/mag;
	 for(k=0;k<2;k++){
	     sc[i][k][j]=p42[j]+l[k]*e42[j];
	 }
     }
 }
 draw_cam_3_osc_pr(); 
 draw_fol1_3_osc_pr(1.5*vp3_var[0],-vp3_var[4],vp3_var[7]-vp3_var[6]);
}

draw_cam_3_osc_pr(){
     double v1[3],v2[3];
     float  n1[3],n2[3];
     int    i,j,k;


     makeobj(CAM);
	   lmbind(MATERIAL,C_CAM); /* steel */
      for (k=0; k<1; k++){
          bgnqstrip();
          for (i=0; i<=POINTS; i++)      
           {
             for(j=0;j<3;j++)
               {
                v1[j]=sc[i][k][j];
                v2[j]=sc[i][k+1][j];
                n1[j]= nsc[i][0][j];
               }
             n3f(n1);
             v3d(v2);
             v3d(v1);
           }
          endqstrip();	  
      }
     closeobj();
}

draw_fol1_3_osc_pr(lm,h,th) /* length, a4, thick */
double lm,h,th;
{
 makeobj(PFOL);
  pushmatrix();
   translate(-lm/2.,0.,th/2.);
   draw_cube(lm,.8*th,th);
   translate(0.,.8*th,0.);
   rotate(1800,'z');
   cylindft(.8*th,th,PI/2.,1.);
   pushmatrix();
    rotate(900,'x');
    draw_plane(.8*th,th,1.);
   popmatrix();
   translate(-lm,0.,0.);
   rotate(900,'z');
   cylindft(.8*th,th,PI/2.,1.);
   pushmatrix();
    rotate(-900,'y');
    draw_plane(th,.8*th,1.);
   popmatrix();   
  popmatrix();
 closeobj();

 makeobj(FOL);
           lmbind(MATERIAL,C_FOL);
  pushmatrix();
   translate(0.,0.,-th);
   if(h>0)
     cylindft(.8*th,th,PI,1.);
   else
     {
      pushmatrix();
       rotate(1800,'z');
       cylindft(.8*th,th,PI,1.);
      popmatrix();
     }
   if(h>0)
     {
      pushmatrix();
       translate(-.8*th,-h-.8*th,0.);
       draw_cube(1.6*th,h+.8*th,th);
      popmatrix();
     }
   else
     {
      pushmatrix();
       translate(-.8*th,0.,0.);
 if(h<-vp3_var[0]*sin(vp4_var[1]))
      draw_cube(1.6*th,-h+.8*th,th);
else
      draw_cube(1.6*th,-h,th);

      popmatrix();
     }
  popmatrix();
  pushmatrix();
/*   if(h<-vp3_var[0]*sin(vp4_var[1]))
    {*/
     rotate(1800,'x');
     /*translate(-(lm-1.6*th)/2.*cos(vp4_var[1]),-.8*th+h,-3*th/2);*/
     translate(-(lm-1.6*th)/2.,-.8*th+h,-3*th/2);
/*    }
   else
    translate(-(lm-1.6*th)/2.*cos(vp4_var[1]),-.8*th-h,-th/2);*/
   callobj(PFOL);
  popmatrix();
 closeobj();
}
