/* vp1_4_ind_rr.c */

#include "head_usycams.h"
#include "def_usycams.h"
#include "objects.h"

double a3M, alp3M, dpsi, phini;

vp1_4_ind_rr(rise)
int rise[1];
{
  double lambda[2];
  double temp;

  vp4_var[1]=1.;
  dpsi=vp4_var[3]*2*PI;
  setlimits1();

  vp4_var[6]=vp4_var[3]*2*PI;
  vp4_var[0]=2*PI/vp4_var[5];
  temp=vp4_var[3];
  vp4_var[3]=1.;
  io_ind_fun(rise,phini,vp4_var[0],POINTS,temp*2*PI,io);
  vp4_var[3]=temp;
  ioanim();
  draw_i_vp3_vp4();
  lambda[0]=(double)vp3_var[6];
  lambda[1]=(double)vp3_var[7];

  vp3_var[2]=a3M;
  vp3_var[3]=alp3M;
  
  cs_4_ind_rr();

 while(!POS0)
  {
    init_vp1(rise,rise);
    dpsi=vp4_var[3]*2*PI;
   
    counter=counter+velz;
    if(counter>points) counter=counter-points;
    if(counter<0) counter=points-1;

    if(PS2 || STP || PHM)	
      {
	draw_i_vp3_vp4();
	if((int)vp4_var[5]<1) vp4_var[5] = 1;	  
	if((int)vp4_var[5]>30) vp4_var[5] = 30;
	if(vp4_var[3]<.05) vp4_var[3] = .05;
	if(vp4_var[3]>1.)  vp4_var[3] = 1.;
	vp4_var[6]=vp4_var[3]*2*PI;
	vp4_var[0]=2*PI/(int)vp4_var[5];
	setlimits();
	temp=vp4_var[3];
	vp4_var[3]=1.;
	io_ind_fun(rise,phini,vp4_var[0],POINTS,temp*2*PI,io);
	vp4_var[3]=temp;
	ioanim();
	cs_4_ind_rr();
      }
    if(D1D || A1D || D3D || A3D || D4D || A4D || LRI || LLE)
      {
	draw_i_vp3_vp4();
	if(vp3_var[0]>1.) vp3_var[0]=1.; if(vp3_var[0]<0.) vp3_var[0]=0.001;
	if(vp3_var[1]>PI) vp3_var[1]=PI; if(vp3_var[1]<0.) vp3_var[1]=0.;
	lambda[0]=(double)vp3_var[6]; lambda[1]=(double)vp3_var[7];
	if(lambda[0]>1.) lambda[0]=1.; if(lambda[0]< -1.) lambda[0]= -1.;
	if(lambda[1]>1.) lambda[1]=1.; if(lambda[1]< -1.) lambda[1]= -1.;
	setlimits();
	cs_4_ind_rr();
      }
    animate(rise,rise);
  }
}

setlimits()
{
  double dphiM,the2M,a2M,nu,de;

  vp3_var[4]    = k1*vp3_var[0]*SGN(cos(vp3_var[1]));
  vp3_var[5]  = -k2*sin(vp3_var[1]);

  phini = PI-vp4_var[1]*PI/(int)vp4_var[5];
  if(D1D || A1D || DPH || STP )
    {
      /*   vp4_var[1] = PI-PI/vp4_var[5];
	   if(PHM)*/

      dphiM = 4*PI/vp4_var[5]/dpsi;
      nu    = dphiM*sin(vp3_var[1]);
      de    = dphiM*cos(vp3_var[1])-1.;
      the2M = atan(nu/de);

      nu    = (1 - dphiM*cos(vp3_var[1]))*vp3_var[0];
      de    = SQR(dphiM)-2*dphiM*cos(vp3_var[1])+1;
      a3M   = nu/de;
      alp3M = (vp3_var[1] - the2M);
      /*   alp3M = atan2(sin(vp3_var[1]),dphiM-cos(vp3_var[1]));*/

      if(A1D || D1D)
	{
	  vp3_var[2] = a3M;
	  vp3_var[3] = alp3M;
	  phini = PI-PI/(int)vp4_var[5];
	}
    }
}

setlimits1()
{
  double dphiM,the2M,a2M,nu,de;

  vp3_var[4]  = k1*vp3_var[0]*SGN(cos(vp3_var[1]));
  vp3_var[5]  = -k2*sin(vp3_var[1]);

  phini = PI-PI/(int)vp4_var[5];
  if(PHM) phini = PI-vp4_var[1]*PI/vp4_var[5];

  dphiM = 4*PI/(int)vp4_var[5]/dpsi;
  nu    = dphiM*sin(vp3_var[1]);
  de    = dphiM*cos(vp3_var[1])-1.;
  the2M = atan(nu/de);

  nu    = (1 - dphiM*cos(vp3_var[1]))*vp3_var[0];
  de    = SQR(dphiM)-2*dphiM*cos(vp3_var[1])+1;
  a3M   = nu/de;

  alp3M = (vp3_var[1] - the2M);
  /*   alp3M = atan2(sin(vp3_var[1]),dphiM-cos(vp3_var[1]));*/
}





